// Code generated by microgen 0.9.1. DO NOT EDIT.

package transport

import (
	"context"

	spaces "git.perx.ru/perxis/perxis-go/pkg/spaces"
	endpoint "github.com/go-kit/kit/endpoint"
)

func Endpoints(svc spaces.Spaces) EndpointsSet {
	return EndpointsSet{
		AbortTransferEndpoint: AbortTransferEndpoint(svc),
		CreateEndpoint:        CreateEndpoint(svc),
		DeleteEndpoint:        DeleteEndpoint(svc),
		GetEndpoint:           GetEndpoint(svc),
		ListEndpoint:          ListEndpoint(svc),
		ListTransfersEndpoint: ListTransfersEndpoint(svc),
		MoveEndpoint:          MoveEndpoint(svc),
		TransferEndpoint:      TransferEndpoint(svc),
		UpdateConfigEndpoint:  UpdateConfigEndpoint(svc),
		UpdateEndpoint:        UpdateEndpoint(svc),
	}
}

func CreateEndpoint(svc spaces.Spaces) endpoint.Endpoint {
	return func(arg0 context.Context, request interface{}) (interface{}, error) {
		req := request.(*CreateRequest)
		res0, res1 := svc.Create(arg0, req.Space)
		return &CreateResponse{Created: res0}, res1
	}
}

func GetEndpoint(svc spaces.Spaces) endpoint.Endpoint {
	return func(arg0 context.Context, request interface{}) (interface{}, error) {
		req := request.(*GetRequest)
		res0, res1 := svc.Get(arg0, req.SpaceId)
		return &GetResponse{Space: res0}, res1
	}
}

func ListEndpoint(svc spaces.Spaces) endpoint.Endpoint {
	return func(arg0 context.Context, request interface{}) (interface{}, error) {
		req := request.(*ListRequest)
		res0, res1 := svc.List(arg0, req.OrgId)
		return &ListResponse{Spaces: res0}, res1
	}
}

func UpdateEndpoint(svc spaces.Spaces) endpoint.Endpoint {
	return func(arg0 context.Context, request interface{}) (interface{}, error) {
		req := request.(*UpdateRequest)
		res0 := svc.Update(arg0, req.Space)
		return &UpdateResponse{}, res0
	}
}

func UpdateConfigEndpoint(svc spaces.Spaces) endpoint.Endpoint {
	return func(arg0 context.Context, request interface{}) (interface{}, error) {
		req := request.(*UpdateConfigRequest)
		res0 := svc.UpdateConfig(arg0, req.SpaceId, req.Config)
		return &UpdateConfigResponse{}, res0
	}
}

func DeleteEndpoint(svc spaces.Spaces) endpoint.Endpoint {
	return func(arg0 context.Context, request interface{}) (interface{}, error) {
		req := request.(*DeleteRequest)
		res0 := svc.Delete(arg0, req.SpaceId)
		return &DeleteResponse{}, res0
	}
}

func TransferEndpoint(svc spaces.Spaces) endpoint.Endpoint {
	return func(arg0 context.Context, request interface{}) (interface{}, error) {
		req := request.(*TransferRequest)
		res0 := svc.Transfer(arg0, req.SpaceID, req.TransferToOrg)
		return &TransferResponse{}, res0
	}
}

func AbortTransferEndpoint(svc spaces.Spaces) endpoint.Endpoint {
	return func(arg0 context.Context, request interface{}) (interface{}, error) {
		req := request.(*AbortTransferRequest)
		res0 := svc.AbortTransfer(arg0, req.SpaceID)
		return &AbortTransferResponse{}, res0
	}
}

func ListTransfersEndpoint(svc spaces.Spaces) endpoint.Endpoint {
	return func(arg0 context.Context, request interface{}) (interface{}, error) {
		req := request.(*ListTransfersRequest)
		res0, res1 := svc.ListTransfers(arg0, req.OrgID)
		return &ListTransfersResponse{Spaces: res0}, res1
	}
}

func MoveEndpoint(svc spaces.Spaces) endpoint.Endpoint {
	return func(arg0 context.Context, request interface{}) (interface{}, error) {
		req := request.(*MoveRequest)
		res0 := svc.Move(arg0, req.SpaceID, req.OrgID)
		return &MoveResponse{}, res0
	}
}
